package jboudny.olympiada;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.util.ArrayList;
import java.util.List;

import java.awt.Color;

public class Tower {

	public int x, y, type;
	
	public int h = 0;

	public List<Block> blocks = new ArrayList<Block>();

	public Tower loadTower(String path) {
		return loadTower(new File(path));
	}

	public static Tower loadTower(File f) {
		Tower t = new Tower();

		try {
			BufferedReader br = new BufferedReader(new FileReader(f));

			String s = null;

			int i = 0;

			while ((s = br.readLine()) != null) {
				String[] words = new String[3];
				words = s.split(" ");

				words = removeSpaces(words);
				System.out.println(s);

				if (words.length >= 3) {
					
				if (i == 0) {
					t.x = Integer.parseInt(words[0]);
					t.y = Integer.parseInt(words[1]);

				} else {
					Block b = new Block();

					switch (words[3]) {
					case "A":
						b.c = new Color(0, 255, 255);
						break;
					case "R":
						b.c = new Color(255, 0, 0);
						break;
					case "G":
						b.c = new Color(0, 255, 0);
						break;
					case "B":
						b.c = new Color(0, 0, 255);
						break;
					case "Y":
						b.c = new Color(255, 255, 0);
						break;
					default:
						System.out.println("Kostka ma neplatnou barvu!");
						System.exit(1);

					}
					
					
					b.x = Integer.parseInt(words[1]);
					b.y = Integer.parseInt(words[2]);

					b.layer = Integer.parseInt(words[0]);
					if (Integer.parseInt(words[0]) > t.h) {
						t.h = Integer.parseInt(words[0]);
					}

					String[] dim = words[4].toLowerCase().split("x");

					b.w = Integer.parseInt(dim[0]);
					b.h = Integer.parseInt(dim[1]);

					t.blocks.add(b);
					
					System.out.println(b);
					
					
				}

				i++;
				}
			}

			br.close();

		} catch (Exception e) {
			e.printStackTrace();
			System.err.println("Chyba pri cteni souboru");
			System.exit(0);
		}

		return t;
	}

	public static String[] removeSpaces(String[] toClean) {
		List<String> words = new ArrayList<String>();
		for (int i = 0; i < toClean.length; i++) {
			if (!toClean[i].equals("")) {
				words.add(toClean[i]);
			}
		}

		String[] clean = new String[words.size()];

		int w = 0;

		for (String s : words) {
			clean[w] = s;
			w++;
		}

		return clean;
	}

}
