package jboudny.olympiada;

import java.util.List;

import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

import org.lwjgl.LWJGLException;
import org.lwjgl.input.Keyboard;
import org.lwjgl.opengl.Display;
import org.lwjgl.opengl.DisplayMode;
import org.lwjgl.opengl.GL11;
import org.lwjgl.util.glu.GLU;

public class WindowManager {
	
	Tower t;
	public JFrame frame;
	
	public WindowManager(Tower t) {
		this.t = t;
	}
	
	public void showDialog() {
		frame = new JFrame();
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.setSize(300, 200);
		frame.setLocationRelativeTo(null);
		frame.setVisible(true);
		
		frame.add(new DialogPanel(this));
		
	}
	
	public void showRecap() {
		
	}
	
	public void showLayer() {
		this.frame.dispose();
		
		
		JFrame frame = new JFrame();
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.setSize(640,480);
		frame.setLocationRelativeTo(null);
		
		int layer = Integer.parseInt(JOptionPane.showInputDialog("Zadejte patro", null));
		
		frame.add(new LayerPanel(t, layer));
		
		frame.setVisible(true);

		
	}
	
	public void showSide() {
		
	}
	
	public void show3D() {
		frame.dispose();
		
		try {
			Display.setDisplayMode(new DisplayMode(640, 480));
			Display.create();	
			
		} catch (LWJGLException e) {
			e.printStackTrace();
		}
		
		int list = DisplayListBuilder.genDL(this.t);
		
		//GL11.glOrtho(0, 64, 0, 48, 0, 1000);
		
		float rotX = 0;
		float rotY = 0;
		
		   GL11.glClearColor(0.0f, 0.0f, 0.0f, 1.0f); // Set background color to black and opaque
		   GL11.glClearDepth(1.0f);                   // Set background depth to farthest
		   GL11.glEnable( GL11.GL_DEPTH_TEST);   // Enable depth testing for z-culling
		   GL11.glDepthFunc( GL11.GL_LEQUAL);    // Set the type of depth-test
		
		while (!Display.isCloseRequested()) {
			GL11.glLoadIdentity();
			GL11.glClear(GL11.GL_COLOR_BUFFER_BIT | GL11.GL_DEPTH_BUFFER_BIT);
			GLU.gluPerspective(60f, 640f/480f, 0.01f, 100f);
			
			GL11.glTranslatef(-t.x/2f, -t.h/2f, -Math.max(t.h, t.y)*2);
			
			GL11.glPushMatrix();
			
			GL11.glTranslatef(t.x/2f, t.h/2f, 0);
			
			GL11.glRotatef(rotX, 0, 1, 0);
			GL11.glRotatef(rotY, 1, 0, 0);
			
			GL11.glTranslatef(-t.x/2f, -t.h/2f, 0);
			
			if (Keyboard.isKeyDown(Keyboard.KEY_UP)) rotY += 0.5f;
			if (Keyboard.isKeyDown(Keyboard.KEY_DOWN)) rotY -= 0.5f;
			
			if (Keyboard.isKeyDown(Keyboard.KEY_LEFT)) rotX += 0.5f;		
			if (Keyboard.isKeyDown(Keyboard.KEY_RIGHT)) rotX -= 0.5f;
			
			GL11.glCallList(list);
			
			GL11.glPopMatrix();
			
			Display.update();
			Display.sync(60);
		}
		
		Display.destroy();
		showDialog();
	}
	
	public void showLayer3D() {
		
	}
	
}
